/**
 * @template T, U
 * @param {(acc: U, value: T) => U} f
 * @param {U} acc
 */
export const Reducer = (f, acc) => {
  function Const(value) {
    this.value = value
  }

  Const.of = function() { return new Const(acc) }
  Const.prototype.map = function() { return this }
  Const.prototype.ap = function(b) {
    return new Const(f(b.value, this.value))
  }
  return Const
}
